#include <sys/socket.h>
#include <netinet/in.h>
#include <sys/select.h>
#include <sys/time.h>
#include <sys/types.h>
#include <stdio.h>
#include <string.h>
#include <limits.h>
#include <poll.h>
#include <errno.h>
#include <unistd.h>
#define MAXLINE 4096
#ifndef OPEN_MAX
#define OPEN_MAX 1024
#endif
in_port_t SERV_PORT = 8888;
int main(int ,char *[]){
	int i, maxi;
	int listenfd, connfd, sockfd;
	int nready;
	char buf[MAXLINE];
	struct pollfd client[OPEN_MAX];
	struct sockaddr_in cliaddr, servaddr;
	socklen_t clilen;
	ssize_t n;
	
	listenfd = socket(AF_INET, SOCK_STREAM, 0);
	
	memset(&servaddr, 0, sizeof servaddr);
	servaddr.sin_family = AF_INET;
	servaddr.sin_addr.s_addr = htonl(INADDR_ANY);
	servaddr.sin_port = htons(SERV_PORT);
	
	if (-1 == bind(listenfd, (struct sockaddr*)&servaddr, sizeof servaddr))
		perror("bind error\n");
	
	listen(listenfd, 1024);
	//client保存了pull监听的描述符，其中client[0]是给listen描述符的
	client[0].fd = listenfd;
	client[0].events = POLLRDNORM;
	for (i = 1; i < OPEN_MAX; i++)
		client[i].fd = -1;
	maxi = 0;
	for (;;) {
		nready = poll(client, maxi+1, -1);
		//如果是监听描述符可读,说明有客户端连入
		if (client[0].revents & POLLRDNORM) {
			clilen = sizeof(cliaddr);
			connfd = accept(listenfd, (struct sockaddr*)&cliaddr, &clilen);
			if (connfd == -1) perror("accept error\n");
			else printf("%d accepted!\n", connfd);
			
			//扫描clien数组，找到下标最小的未用的来存客户端描述符
			for (i = 1; i < OPEN_MAX; i++) {
				if (client[i].fd < 0) {
					client[i].fd = connfd;
					break;
				}
			}
			if (i == OPEN_MAX) perror("too many clients.\n");
			client[i].events = POLLRDNORM;
			if (i > maxi) maxi = i;
			if (--nready <= 0) continue;
		}
		//扫描所有的客户端描述符
		for (i = 1; i <= maxi; i++) {
			if ((sockfd = client[i].fd) < 0) continue;
			//POLLERR不需要监听，如果有错误的话poll返回时会自动加上
			if (client[i].revents & (POLLRDNORM | POLLERR)) {
				//读到EOF或错误关闭描述符
				if ((n = read(sockfd, buf, MAXLINE)) <= 0) {
					close(sockfd);
					client[i].fd = -1;
					if (n < 0) perror("read error\n");
				//回显给客户端
				} else {
					write(sockfd, buf, n);
				}
				if (--nready <= 0) break;
			}
		}
	}
	return 0;
}
